<?php
// If you wanna translate this file or ad more spiders, you can find instructions in this post
// http://www.simplemachines.org/community/index.php?topic=19243.msg156339#msg156339
// The only template in the file.

function template_main()

{

	global $context, $settings, $options, $scripturl, $txt;

	// Display the table header and linktree.

	echo '

	<div style="padding: 3px;">', theme_linktree(), '</div>';

	$brokendown = array (
								'Homies' => array(),
								'Visitors' => array(),
								'Robotas' => array(),
						);

	foreach($context['members'] AS $key => $member)
	{
		$spider = getAgent($member['query']['USER_AGENT'], $context['members'][$key]['name'], $agent, $member['id'] == 0);
		$context['members'][$key]['agent'] = $agent;
		$member['query']['USER_AGENT'] = isset($member['query']['USER_AGENT']) ? $member['query']['USER_AGENT'] : '';

		if ( $member['id'] != 0 )
					$brokendown['Homies'][] = &$context['members'][$key];
				else if ( $spider )  
					$brokendown['Robotas'][] = &$context['members'][$key];
				else
					$brokendown['Visitors'][] = &$context['members'][$key];
	}

	echo '
	<table cellpadding="1" cellspacing="1" border="0" width="100%" class="tborder">
		<tr class="catbg">
			<td style="width:30%; padding:4px;"><a href="' . $scripturl . '?action=who;sort=user', $context['sort_direction'] == 'down' && $context['sort_by'] == 'user' ? ';asc' : '', '">Visitors On-Line ', $context['sort_by'] == 'user' ? '<img src="' . $settings['images_url'] . '/sort_' . $context['sort_direction'] . '.gif" alt="" border="0" />' : '', '</a></td>
			<td style="width:20%; padding:4px;"><a href="' . $scripturl . '?action=who;sort=time', $context['sort_direction'] == 'down' && $context['sort_by'] == 'time' ? ';asc' : '', '"> Time ', $context['sort_by'] == 'time' ? '<img src="' . $settings['images_url'] . '/sort_' . $context['sort_direction'] . '.gif" alt="" border="0" />' : '', '</a></td>
			<td style="padding:4px;">Action</td>
		</tr>
		<tr>
			<td colspan="3">';

//	echo '<pre>'; print_r($brokendown['Spiders']); echo '</pre>'; return;
	foreach($brokendown AS $group => $members)
	{
		echo '
			<table cellpadding="3" cellspacing="1" border="0" width="100%">


';

		// This is used to alternate the color of the background.
		$alternate = true;

		// For every member display their name, time and action (and more for admin).
		foreach ($members as $member)
		{
		// $alternate will either be true or false.  If it's true, use "windowbg2" and otherwise use "windowbg".
			echo '
			<tr>
				<td class="windowbg', $alternate ? '2' : '', '" width="30%">';
			// Guests don't have information like icq, msn, y!, and aim... and they can't be messaged.
			if (!$member['is_guest'])
			{
				echo '
					<div style="float: right; width: 14ex; padding: 0 12px;">
					', $context['can_send_pm'] ? '<a href="' . $member['online']['href'] . '" title="' . $member['online']['label'] . '">' : '', $settings['use_image_buttons'] ? '<img src="' . $member['online']['image_href'] . '" alt="' . $member['online']['text'] . '" style="vertical-align:middle" />' : $member['online']['text'], $context['can_send_pm'] ? '</a>' : '', '
					', $member['icq']['link'], ' ', $member['msn']['link'], ' ', $member['yim']['link'], ' ', $member['aim']['link'], '
				</div>';
		}

		echo '
				<span', $member['is_hidden'] ? ' style="font-style: italic;"' : '', '><b>', $member['is_guest'] ? $member['name'] : '<a href="' . $member['href'] . '" title="' . $txt[92] . ' ' . $member['name'] . '"' . (empty($member['color']) ? '' : ' style="color: ' . $member['color'] . '"') . '>' . $member['name'] . '</a>', '</b></span>';

		if ( !empty($member['ip']) )
			echo ' <br /> <span class="smalltext">[<a href="' . $scripturl . '?action=trackip;searchip=' . $member['ip'] . '" target="_blank" title="' . $member['ip'] . '" class="smalltext"><b>' . $member['ip'] . '</b></a>, <acronym title="' . $member['query']['USER_AGENT'] . '">' . $member['agent'] . '</acronym>]</span>';	
		echo '
			</td>
			<td nowrap="nowrap" class="windowbg', $alternate ? '2' : '', '" width="20%">Czas ', $member['time'], ' </td>
			<td class="windowbg', $alternate ? '2' : '', '"> ', $member['action'], '</td>
		</tr>
		';

		// Switch alternate to whatever it wasn't this time. (true -> false -> true -> false, etc.)
		$alternate = !$alternate;
	}
		echo '</table>';
	}

	echo '
				</td>
			</tr>
		</table>';

	echo '
	<br /><br /><table cellpadding="3" cellspacing="0" border="0" width="100%">
	<tr><td>
		<b style="font-size:10px;">', $txt[139], ':</b> ', $context['page_index'], '</td>
	</tr></table>';
}

function getAgent( &$user_agent, &$user_name, &$result, $guest )

{

$known_agents = array (

//////// Search Spiders ////////////

//The big cheese spiders detected by SMF by default 	Originating Site	/Website	Description				Recently Seen ?
	array(
		'agent' => 'Googlebot', 
		'spidername' => 'Google spider', 
		'spider' => true,
	),
	// Google			http://www.google.com				The main spider used by Google				Yes 05/08

	array(
		'agent' => 'Msn', 
		'spidername' => 'MsnBot', 
		'spider' => true,
	),
	// Msn			http://www.msn.com				The main spider used by MSN				Yes 05/08

	array(
		'agent' => 'Yahoo!', 
		'spidername' => 'Slurp', 
		'spider' => true,
	),
	// Yahoo			http://www.yahoo.com				Worlds most aggressive spider				Yes 05/08

// MAJOR spiders		Originating Site 	Website		Description							Recently Seen ?
	array(
		'agent' => 'Ask', 
		'spidername' => 'Teoma', 
		'spider' => true,
	),
	// Ask.com			http://www.ask.com				Spider for Ask Search Engine				Yes 05/08

	array(
		'agent' => 'Baidu', 
		'spidername' => 'Baiduspider', 
		'spider' => true,
	),
	// Baidu			http://www.baidu.com				Spider for Chinese search engine				Yes 05/08

	array(
		'agent' => 'GigaBot', 
		'spidername' => 'Gigabot', 
		'spider' => true,
	),
	// Gigablast		http://www.gigablast.com			Another heavily travelled spider				Yes 05/08

	array(
		'agent' => 'Google-AdSense', 
		'spidername' => 'Mediapartners-Google', 
		'spider' => true,
	),
	// Google			http://www.google.com				Spider related to Adsense/Adwords			Yes 05/08

	array(
		'agent' => 'Google-Adwords', 
		'spidername' => 'AdsBot-Google', 
		'spider' => true,
	),
	// Google			http://www.google.com				Spider related to Adwords					Yes 05/08

	array(
		'agent' => 'Google-SA', 
		'spidername' => 'gsa-crawler', 
		'spider' => true,
	),
	// Google			http://www.google.com				Google Search Appliance Spider				Yes 05/08

	array(
		'agent' => 'Google-Image', 
		'spidername' => 'Googlebot-Image', 
		'spider' => true,
	),
	// Google			http://www.google.com				Spider for google image search				Yes 05/08

	array(
		'agent' => 'InternetArchive', 
		'spidername' => 'ia_archiver-web.archive.org', 
		'spider' => true,
	),
	// Archive			http://www.archive.org			Way back When machine Spider				Yes 05/08

	array(
		'agent' => 'Alexa', 
		'spidername' => 'ia_archiver', 
		'spider' => true,
	),
	// Alexa			http://www.alexa.com				*Must be detected after Internet Archive		Yes 05/08

	array(
		'agent' => 'Omgili', 
		'spidername' => 'omgilibot', 
		'spider' => true,
	),
	// Omgili			http://www.omgili.com				Extremely aggressive Messageboard/forum Spider	Yes 05/08

	array(
		'agent' => 'Speedy Spider', 
		'spidername' => 'Speedy Spider', 
		'spider' => true,
	),
	// EntireWeb		http://www.entireweb.com			Entire web spider						Yes 05/08

	array(
		'agent' => 'Yahoo', 
		'spidername' => 'yahoo', 
		'spider' => true,
	),
	// Yahoo			http://www.yahoo.com				For Yahoo Publisher Network  (a variety in use)	Yes 05/08

	array(
		'agent' => 'Yahoo JP', 
		'spidername' => 'Y!J', 
		'spider' => true,
	),
	// Yahoo			http://www.yahoo.co.jp				Spider for Yahoo Japan				No

// Checkers/Testers/Robots	Originating Site		Website		Description						Recently Seen ?
	array(
		'agent' => 'DeadLinksChecker', 
		'spidername' => 'link validator', 
		'spider' => true,
	),
	// Dead-Links		http://www.dead-links.com/			Checks your site for dead/bad links			Yes 05/08

	array(
		'agent' => 'W3C Validator', 
		'spidername' => 'W3C_Validator', 
		'spider' => true,
	),
	// W3C			http://validator.w3.org			Checks standards validity of any html/xhtml page	Yes 05/08

	array(
		'agent' => 'W3C CSSValidator', 
		'spidername' => 'W3C_CSS_Validator', 
		'spider' => true,
	),
	// W3C 			http://jigsaw.w3.org/css-validator/		Checks standards validity of css stylesheets	Yes 05/08

	array(
		'agent' => 'W3C FeedValidator', 
		'spidername' => 'FeedValidator', 
		'spider' => true,
	),
	// W3C			http://validator.w3.org/feed/ 		Checks standards validity of atom/rss feeds		Yes 05/08

	array(
		'agent' => 'W3C LinkChecker', 
		'spidername' => 'W3C-checklink', 
		'spider' => true,
	),
	// W3C 			http://validator.w3.org/checklink		Checks links on any html/xhtml page are valid 	Yes 05/08

	array(
		'agent' => 'W3C mobileOK', 
		'spidername' => 'W3C-mobileOK', 
		'spider' => true,
	),
	// W3C			http://www.w3.org/2006/07/mobileok-ddc Checks page for how good it is for mobiles		Yes 05/08

	array(
		'agent' => 'W3C P3PValidator', 
		'spidername' => 'P3P Validator', 
		'spider' => true,
	),
	// W3C			http://www.w3.org/P3P/validator.html	Checks something??						Yes 05/08

// Feed readers			Originating Site		Website		Description							Recently Seen ?
	array(
		'agent' => 'Bloglines', 
		'spidername' => 'Bloglines', 
		'spider' => true,
	),
	// Bloglines		http://www.bloglines.com			Spider for blog/rich web content (owned by Ask)	Yes 05/08

	array(
		'agent' => 'Feedburner', 
		'spidername' => 'Feedburner', 
		'spider' => true,
	),
	// Feedburner		http://www.feedburner.com			Another RSS feed reader					Yes 05/08

// Website Thumbnail/Snapshot/Thumbshot takers	Originating Site	/Website	Description					Recently Seen ?
	array(
		'agent' => 'SnapBot', 
		'spidername' => 'Snapbot', 
		'spider' => true,
	),
	// Snap			http://www.snap.com				Shapshots provider						Yes 05/08

	array(
		'agent' => 'Picsearch', 
		'spidername' => 'psbot', 
		'spider' => true,
	),
	// Picsearch		http://www.picsearch.com			Picture/Image Search Engine				Yes 05/08

	array(
		'agent' => 'Websnapr', 
		'spidername' => 'Websnapr', 
		'spider' => true,
	),
	// Websnapr		http://www.websnapr.com			Snapshot/site screenshot taker				Yes 05/08

// More MINOR Spiders/Robots	Originating Site		Website		Description						Recently Seen ?
	array(
		'agent' => 'AllTheWeb', 
		'spidername' => 'FAST-WebCrawler', 
		'spider' => true,
	),
	// All The Web		http://www.alltheweb.com			Spider for alltheweb (now owned by Yahoo)		No

	array(
		'agent' => 'Altavista', 
		'spidername' => 'Scooter', 
		'spider' => true,
	),
	// Altavista		http://www.altavista.com			Another Major Search Engine spider		No

	array(
		'agent' => 'Asterias', 
		'spidername' => 'asterias', 
		'spider' => true,
	),
	// AOL			http://www.aol.com				Media Spider							Yes 05/08

	array(
		'agent' => '192bot', 
		'spidername' => '192.comAgent', 
		'spider' => true,
	),
	// 192			http://www.192.com				Spider to index for 192.com					No

	array(
		'agent' => 'AbachoBot', 
		'spidername' => 'ABACHOBot', 
		'spider' => true,
	),
	// Abacho			http://www.abacho.com			Spider for multi language search engine/translator	Yes 05/08

	array(
		'agent' => 'Abdcatos', 
		'spidername' => 'abcdatos', 
		'spider' => true,
	),
	// Abdcatos		http://www.abcdatos.com/botlink/		Spider for Italian Search Engine				Yes 05/08

	array(
		'agent' => 'Acoon', 
		'spidername' => 'Acoon', 
		'spider' => true,
	),
	// Acoon			http://www.acoon.de				Spider for small search engine				Yes 05/08

	array(
		'agent' => 'Accoona', 
		'spidername' => 'Accoona', 
		'spider' => true,
	),
	// Accoona			http://www.accoona.com			Spider for Accoona						Yes 05/08

	array(
		'agent' => 'BecomeBot', 
		'spidername' => 'BecomeBot', 
		'spider' => true,
	),
	// BecomeBot		http://www.become.com			Shopping/Products type search engine			Yes 05/08

	array(
		'agent' => 'Daumoa', 
		'spidername' => 'Daumoa', 
		'spider' => true,
	),
	// Daum			http://ws.daum.net/aboutkr.html		South Korean Search Engine Spider			Yes 05/08

	array(
		'agent' => 'Exabot', 
		'spidername' => 'Exabot', 
		'spider' => true,
	),
	// Exalead			http://www.exalead.com				Spider for small search engine			Yes 05/08

	array(
		'agent' => 'Furl', 
		'spidername' => 'Furlbot', 
		'spider' => true,
	),
	// Furl			http://www.furl.net				Spider for Furl social bookmarking site			Yes 05/08

	array(
		'agent' => 'FyperSpider', 
		'spidername' => 'FyberSpider', 
		'spider' => true,
	),
	// FyberSearch		http://www.fybersearch.com			Spider for Small Search Engine				Yes 05/08

	array(
		'agent' => 'Geona', 
		'spidername' => 'GeonaBot', 
		'spider' => true,
	),
	// Geona			http://www.geona.com				Spider for another small search engine			Yes 05/08

	array(
		'agent' => 'GirafaBot', 
		'spidername' => 'Girafabot', 
		'spider' => true,
	),
	// Girafabot		http://www.girafa.com/			Thumbshot provider						Yes 05/08

	array(
		'agent' => 'GoSeeBot', 
		'spidername' => 'GoSeeBot', 
		'spider' => true,
	),
	// GoSee			http://www.gosee.com/bot.html		Spider for small search engine 				Yes 05/08

	array(
		'agent' => 'Ichiro', 
		'spidername' => 'ichiro', 
		'spider' => true,
	),
	// Ichiro			http://help.goo.ne.jp/door/crawler.html 	Spider for Japanese search engine			Yes 05/08

	array(
		'agent' => 'LapozzBot', 
		'spidername' => 'LapozzBot', 
		'spider' => true,
	),
	// Lapozz			http://www.lapozz.hu			 	Spider for Hungarian search engine			Yes 05/08

	array(
		'agent' => 'Looksmart', 
		'spidername' => 'WISENutbot', 
		'spider' => true,
	),
	// WISENutbot		http://www.looksmart.com			Spider related to advertising 				Yes 05/08

	array(
		'agent' => 'Lycos', 
		'spidername' => 'Lycos_Spider', 
		'spider' => true,
	),
	// Lycos			http://www.lycos.com				Spider for search engine					No

	array(
		'agent' => 'Majestic12', 
		'spidername' => 'MJ12bot/v2', 
		'spider' => true,
	),
	// Majestic12		http://www.majestic12.co.uk/		Distributed Search Engine Project			Yes 05/08

	array(
		'agent' => 'MLBot', 
		'spidername' => 'MLBot', 
		'spider' => true,
	),
	// MetaDataLabs	http://www.metadatalabs.com/		Media indexing spider						Yes 05/08

	array(
		'agent' => 'MSRBOT', 
		'spidername' => 'msrbot', 
		'spider' => true,
	),
	// Microsoft Research	http://research.microsoft.com/research/sv/msrbot/  Microsoft Research bot			No

	array(
		'agent' => 'Naver', 
		'spidername' => 'NaverBot', 
		'spider' => true,
	),
	// Naver			http://www.naver.com				South Korean Search Engine Spider			Yes 05/08

	array(
		'agent' => 'Naver', 
		'spidername' => 'Yeti', 
		'spider' => true,
	),
	// Naver			http://www.naver.com			Another NaverBot for the South Korean Search Engine	Yes 05/08

	array(
		'agent' => 'NoxTrumBot', 
		'spidername' => 'noxtrumbot', 
		'spider' => true,
	),
	// Noxtrum		http://www.noxtrum.com			Spider for Spanish search engine				Yes 05/08

	array(
		'agent' => 'OmniExplorer', 
		'spidername' => 'OmniExplorer_Bot', 
		'spider' => true,
	),
	// Omniexplorer		http://www.omni-explorer.com/		Spider								No

	array(
		'agent' => 'OnetSzukaj', 
		'spidername' => 'OnetSzukaj', 
		'spider' => true,
	),
	// Onet			http://szukaj.onet.pl				Polish Search Engine Spider					Yes 05/08

	array(
		'agent' => 'ScrubTheWeb', 
		'spidername' => 'Scrubby', 
		'spider' => true,
	),
	// ScrubTheWeb		http://www.scrubtheweb.com		Spider for Scrub the web					Yes 05/08

	array(
		'agent' => 'SearchSight', 
		'spidername' => 'SearchSight', 
		'spider' => true,
	),
	// Searchsight		http://www.searchsite.com			Another search engine						Yes 05/08

	array(
		'agent' => 'Seeqpod', 
		'spidername' => 'Seeqpod', 
		'spider' => true,
	),
	// Seeqpod			http://www.seeqpod.com		 	Spider for search engine (the google for mp3 files)	Yes 05/08

	array(
		'agent' => 'Shablast', 
		'spidername' => 'ShablastBot', 
		'spider' => true,
	),
	// ShaBlast 		http://www.shablast.com			Spider for a small search engine				Yes 05/08

	array(
		'agent' => 'SitiDiBot', 
		'spidername' => 'SitiDiBot', 
		'spider' => true,
	),
	// Sitidi			http://www.sitidi.net				Spider for italian Sitidi search engine			Yes 05/08

	array(
		'agent' => 'Slider', 
		'spidername' => 'silk/1.0', 
		'spider' => true,
	),
	// Slider			http://www.slider.com			Spider for Slider, but it only spiders DMOZ entries	Yes 05/08

	array(
		'agent' => 'Sogou', 
		'spidername' => 'Sogou', 
		'spider' => true,
	),
	//Sogou			http://www.sogou.com				Spider for Chinese search engine				Yes 05/08

	array(
		'agent' => 'StackRambler', 
		'spidername' => 'StackRambler', 
		'spider' => true,
	),
	// StackRambler 	http://www.rambler.ru/doc/robots.shtml	Spider for Russian portal/search engine  	Yes 05/08

	array(
		'agent' => 'SurveyBot', 
		'spidername' => 'SurveyBot', 
		'spider' => true,
	),
	// Domaintools		http://www.domaintools.com			Probe for website statistics (WhoIs  Source)		Yes 05/08

	array(
		'agent' => 'Walhello', 
		'spidername' => 'appie', 
		'spider' => true,
	),
	// Wahello			http://www.wahello.com/			Spider for wahello						No

	array(
		'agent' => 'WebAlta', 
		'spidername' => 'WebAlta', 
		'spider' => true,
	),
	// WebAlta		http://www.webalta.net			Russian Search Engine						Yes 05/08

	array(
		'agent' => 'YacyBot', 
		'spidername' => 'yacybot', 
		'spider' => true,
	),
	// Yacy			http://www.yacy.com			 	Crawler for distributed search engine			Yes 05/08

	array(
		'agent' => 'YodaoBot', 
		'spidername' => 'YodaoBot', 
		'spider' => true,
	),
	// Yodao			http://www.yodao.com				Spider for Chinese Search Engine				Yes 05/08

// Google-Wanna-Be's - Spiders/Robots for Startups	Originating Site	/Website		Description			Recently Seen ?
	array(
		'agent' => 'Charlotte', 
		'spidername' => 'Charlotte', 
		'spider' => true,
	),
	// SearchMe (Beta) 	http://www.searchme.com/support/ 	Spider for new search engine (in beta)		  	Yes 05/08

	array(
		'agent' => 'DiscoBot', 
		'spidername' => 'DiscoBot', 
		'spider' => true,
	),
	// DiscoveryEngine	http://discoveryengine.com/discobot.html	Spider for new search engine startup		Yes 05/08

	array(
		'agent' => 'EnaBot', 
		'spidername' => 'EnaBot', 
		'spider' => true,
	),
	// EnaBall			http://www.enaball.com/crawler.html	Experimental new spider					Yes 05/08

	array(
		'agent' => 'Gaisbot', 
		'spidername' => 'Gaisbot', 
		'spider' => true,
	),
	// Gaisbot			http://gais.cs.ccu.edu.tw/robot.php	Spider for search engine startup				Yes 05/08

	array(
		'agent' => 'Kalooga', 
		'spidername' => 'kalooga', 
		'spider' => true,
	),
	// Kalooga			http://www.kalooga.com			Spider for new media search engine (in beta)		Yes 05/08

	array(
		'agent' => 'ScoutJet', 
		'spidername' => 'ScoutJet', 
		'spider' => true,
	),
	// ScoutJet		http://www.scoutjet.com/		Spider for new search engine (by the DMOZ founders)	Yes 05/08

	array(
		'agent' => 'TinEye', 
		'spidername' => 'TinEye', 
		'spider' => true,
	),
	// TinEye			http://tineye.com/crawler.html		Spider for search engine startup				Yes 05/08

	array(
		'agent' => 'Twiceler', 
		'spidername' => 'twiceler', 
		'spider' => true,
	),
	// Culli			http://www.cuill.com/twiceler/robot.html	Experimental Spider, (aggressive)			Yes 05/08

// Software			Originating Site		Website		Description							Recently Seen ?
	array(
		'agent' => 'GSiteCrawler', 
		'spidername' => 'GSiteCrawler', 
		'spider' => true,
	),
	// GSiteCrawler		http://www.gsitecrawler.com/		Windows Based Sitemap Generator Software		Yes 05/08

	array(
		'agent' => 'HTTrack', 
		'spidername' => 'HTTrack', 
		'spider' => true,
	),
	// HTrack			http://www.httrack.com			HTTrack Website Copier - Offline Browser		Yes 05/08

	array(
		'agent' => 'Wget', 
		'spidername' => 'Wget', 
		'spider' => true,
	),
	// WGet Software	http://www.gnu.org/software/wget/	GNU software to retrieve files				Yes 05/08
// Reason for detecting these: They can be very intensive. So seeing them in use, enables you to block if necessary.

//Rest of spiders:
	array (
		'agent' => 'Openbot', 
		'spidername' => 'Openfind spider',
		'spider' => true,
	),

	array (
		'agent' => 'Ask Jeeves', 
		'spidername' => 'Ask Jeeves',
		'spider' => true,
	),

	array (
		'agent' => 'IBM_Planetwide', 
		'spidername' => 'IBM_Planetwide',
		'spider' => true,
	),

	array (
		'agent' => 'Inktomi Slurp', 
		'spidername' => 'Inktomi Slurp',
		'spider' => true,
	),

	array (
		'agent' => 'Feedfetcher-Google', 
		'spidername' => 'Feedfetcher-Google',
		'spider' => true,
	),

	array (
		'agent' => 'http://www.relevantnoise.com', 
		'spidername' => 'relevantNOISE',
		'spider' => true,
	),

	array (
		'agent' => 'NewsGatorOnline/2.0', 
		'spidername' => 'NewsGatorOnline',
		'spider' => true,
	),

	array (
		'agent' => 'ping.blo.gs/2.0', 
		'spidername' => 'ping.blo.gs',
		'spider' => true,
	),

	array (
		'agent' => 'Jakarta Commons-HttpClient/3.0.1', 
		'spidername' => 'Amazon',
		'spider' => true,
	),

	array (
		'agent' => 'Jakarta Commons-HttpClient/3.0-rc2', 
		'spidername' => 'Amazon',
		'spider' => true,
	),

	array (
		'agent' => 'www.fi crawler',
		'spidername' => 'www.fi spider',
		'spider' => true,
	),



/////////// phones ////////////

		array (
				'agent' => 'Nokia', 
		),

		array (
				'agent' => 'Samsung',
		),

		array (
				'agent' => 'Ericsson',
		),

		array (
				'agent' => 'Siemens',
		),

		array (
				'agent' => 'Motorola',
		),

////////////// browsers /////////////

		array (
				'agent' => 'Opera',
		),

		array (
				'agent' => 'Firefox',
		),

		array (
				'agent' => 'Firebird',
		),

		array (
				'agent' => 'Safari',
		),

		array (
				'agent' => 'Google Desktop',
		 ),

		array (
				'agent' => 'Netscape',
		),

		array (
				'agent' => 'MyIE2',
		),

		array (
				'agent' => 'Konqueror',
		),

		array (
				'agent' => 'Galeon',
		),

		array (
				'agent' => 'KMeleon',
		),

		array (
				'agent' => 'NG/2.0',
		),

		array (
				'agent' => 'Gecko',
				'name' => 'Mozilla',
		),

		array (
				'agent' => 'MSIE',
				'name' => 'IE',
		),

		array (
				'agent' => 'Epiphany',
		), 

	);

foreach( $known_agents AS $poss )
		if (strpos(strtolower($user_agent), strtolower($poss['agent'])) !== false)
		{
			if ( $guest && isset($poss['spider']) && $poss['spider'] )
				$user_name = isset($poss['spidername']) ? $poss['spidername'] : (isset($poss['name']) ? $poss['name'] : $poss['agent']); 
			$result = isset($poss['name']) ? $poss['name'] : $poss['agent']; 
			return isset($poss['spider']) && $poss['spider'];
		}
	$result = $user_agent;
	return false;
}

?>